Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1377038

Summary: Review Request: sxhkd - Simple X hotkey daemon
Product: [Fedora] Fedora Reporter: Oles Pidgornyy <pidgornyy>
Component: Package ReviewAssignee: gil cattaneo <puntogil>
Status: ON_QA --- QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: LailahFSF, package-review, puntogil
Target Milestone: ---Flags: puntogil: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:

Description Oles Pidgornyy 2016-09-17 23:25:32 UTC
Spec URL: https://pidgornyy.fedorapeople.org/review/sxhkd.spec
SRPM URL: https://pidgornyy.fedorapeople.org/review/sxhkd-0.5.6-1.fc24.src.rpm

Description:
sxhkd is an X daemon that reacts to input events by executing commands.

Its configuration file is a series of bindings that define the associations between the input events and the commands.

The format of the configuration file supports a simple notation for mapping multiple shortcuts to multiple commands in parallel.

Note from the packager:
A while ago I brought the tiling window manager bspwm to Fedora (1317282). While bspwm does not depend on sxhkd, and it is both possible to use bspwm with a different hotkey deamon and sxhkd with a different window manager, they are usually used in unison. Both programs are written by the same author and work great together. Most bspwm guides and also the official documentation suggest using sxhkd as hotkey daemon.

Fedora Account System Username: pidgornyy

Comment 1 Sylvia Sánchez 2016-09-18 16:20:07 UTC
I can help you, if you want. Already requested to be assigned to this package.  But I'm not sure this is the correct way, through Bugzilla.

Comment 3 gil cattaneo 2016-09-18 19:35:24 UTC
(In reply to Filip Szymański from comment #2)
> 1) Lose the Group tag.
i agree
> 2) Source0 should look like this:
> https://github.com/baskerville/%{name}/archive/%{version}.tar.gz#/%{name}-
> %{version}.tar.gz

or 

https://github.com/baskerville/%{name}/archive/%{version}/%{name}- %{version}.tar.gz

> See: https://fedoraproject.org/wiki/Packaging:SourceURL#Git_Tags


have time for this https://bugzilla.redhat.com/show_bug.cgi?id=1366845 ?

Comment 4 gil cattaneo 2016-09-18 19:46:07 UTC
other issues:
missing BuildRequires: gcc or gcc-c++
https://fedoraproject.org/wiki/Packaging:C_and_C%2B%2B#BuildRequires_and_Requires
missing license file
please, add
%license LICENSE
%doc README.md
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text

Comment 5 gil cattaneo 2016-09-18 20:14:56 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)", "Unknown or generated". 11 files have unknown
     license. Detailed output of licensecheck in
     /home/gil/1377038-sxhkd/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[!]: Package contains systemd file(s) if in need.
 ./contrib/systemd/sxhkd.service
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 8 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in sxhkd-
     debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: sxhkd-0.5.6-1.fc26.i686.rpm
          sxhkd-debuginfo-0.5.6-1.fc26.i686.rpm
          sxhkd-0.5.6-1.fc26.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (debuginfo)
-------------------
Checking: sxhkd-debuginfo-0.5.6-1.fc26.i686.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
sxhkd-debuginfo (rpmlib, GLIBC filtered):

sxhkd (rpmlib, GLIBC filtered):
    /bin/sh
    libc.so.6
    libxcb-keysyms.so.1
    libxcb.so.1
    rtld(GNU_HASH)



Provides
--------
sxhkd-debuginfo:
    sxhkd-debuginfo
    sxhkd-debuginfo(x86-32)

sxhkd:
    sxhkd
    sxhkd(x86-32)



Source checksums
----------------
https://github.com/baskerville/sxhkd/archive/0.5.6.tar.gz :
  CHECKSUM(SHA256) this package     : 72366eea4d7ed17a3a9eab5257e59edf9a7cd63b926af1dca2d895dfefaff995
  CHECKSUM(SHA256) upstream package : 72366eea4d7ed17a3a9eab5257e59edf9a7cd63b926af1dca2d895dfefaff995


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1377038 --plugins C/C++ -m fedora-rawhide-i386
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 6 gil cattaneo 2016-09-18 20:16:15 UTC
issues:
missing BuildRequires:	gcc
https://fedoraproject.org/wiki/Packaging:C_and_C%2B%2B#BuildRequires_and_Requires
missing license file
please, add
%license LICENSE
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text

Comment 7 fszymanski 2016-09-18 21:00:30 UTC
One more thing, this package has a systemd unit file.

See: https://fedoraproject.org/wiki/Packaging:Systemd#Packaging

Comment 8 Oles Pidgornyy 2016-09-18 21:44:26 UTC
Thank you Gil and Filip.

In my previous spec files I always used the Group tag, I know that is not used anymore, but it doesn't hurt having it either (it was never a problem).
https://fedoraproject.org/wiki/RPMGroups


Changelog:
- removed Group
- fixed Source0
- added BuildRequires: gcc
- added %license LICENSE and %doc README.asciidoc
- added systemd service according to https://fedoraproject.org/wiki/Packaging:Systemd

The spec and srpm files from my first comment have been updated.

Comment 9 gil cattaneo 2016-09-18 21:49:40 UTC
T(In reply to Oles Pidgornyy from comment #8)
> Thank you Gil and Filip.
> 
> In my previous spec files I always used the Group tag, I know that is not
> used anymore, but it doesn't hurt having it either (it was never a problem).
> https://fedoraproject.org/wiki/RPMGroups
> 
> 
> Changelog:
> - removed Group
> - fixed Source0
> - added BuildRequires: gcc
> - added %license LICENSE and %doc README.asciidoc
> - added systemd service according to
This is useless "Source1:	%{url}/raw/%{version}/contrib/systemd/%{name}.service". this file "contrib/systemd/sxhkd.service" is already present in the source archive
> https://fedoraproject.org/wiki/Packaging:Systemd
> 
> The spec and srpm files from my first comment have been updated.

Comment 10 gil cattaneo 2016-09-18 21:53:35 UTC
 ...and are missing these scripts:
https://fedoraproject.org/wiki/Packaging:Scriptlets?rd=Packaging:ScriptletSnippets#Systemd

Comment 11 Oles Pidgornyy 2016-09-18 21:55:58 UTC
OK, the file is in ~/rpmbuild/BUILD/sxhkd-0.5.6/contrib/systemd/sxhkd.service, but how do access this in the spec? It is OK to use %{_builddir}/%{name}-%{version}/contrib/systemd or is that too "hacky"? Is there a better way?

Comment 12 gil cattaneo 2016-09-18 21:59:35 UTC
(In reply to Oles Pidgornyy from comment #11)
> OK, the file is in
> ~/rpmbuild/BUILD/sxhkd-0.5.6/contrib/systemd/sxhkd.service, but how do
> access this in the spec? It is OK to use
> %{_builddir}/%{name}-%{version}/contrib/systemd or is that too "hacky"? Is
> there a better way?

usual should be:
install -p -D -m 0644 contrib/systemd/%{name}.service %{buildroot}/%{_unitdir}/

Comment 13 gil cattaneo 2016-09-18 22:01:38 UTC
run "koji build --scratch --nowait rawhide path/to/file.src.rpm" for check the changes

Comment 14 gil cattaneo 2016-09-18 22:04:14 UTC
and maybe you lost my request to review in exchange https://bugzilla.redhat.com/show_bug.cgi?id=1366845

Comment 15 gil cattaneo 2016-09-19 08:03:10 UTC
Seem all ok now, approved

Comment 16 Gwyn Ciesla 2017-02-22 22:22:40 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/sxhkd

Comment 17 Fedora Update System 2017-06-18 20:21:49 UTC
sxhkd-0.5.7-1.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-aef46593b7

Comment 18 Fedora Update System 2017-06-18 20:40:59 UTC
sxhkd-0.5.7-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-824d1161bd

Comment 19 Fedora Update System 2017-06-18 21:16:25 UTC
sxhkd-0.5.7-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-71f21cedb9

Comment 20 Fedora Update System 2017-06-19 15:51:23 UTC
sxhkd-0.5.7-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-824d1161bd

Comment 21 Fedora Update System 2017-06-19 15:51:33 UTC
sxhkd-0.5.7-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-71f21cedb9

Comment 22 Fedora Update System 2017-06-19 19:23:44 UTC
sxhkd-0.5.7-1.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-aef46593b7

Comment 23 Fedora Update System 2017-07-21 00:33:42 UTC
sxhkd-0.5.8-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-0fe63e931c

Comment 24 Fedora Update System 2017-07-23 06:54:22 UTC
sxhkd-0.5.8-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-26bd56d311

Comment 25 Fedora Update System 2017-07-23 06:56:37 UTC
sxhkd-0.5.8-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-0fe63e931c

Comment 26 Fedora Update System 2017-07-23 09:58:29 UTC
sxhkd-0.5.8-1.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-9c4a3ece9c